/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-30 at 19:21:28 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

/**
 * A database instance resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DatabaseInstance extends com.google.api.client.json.GenericJson {

  /**
   * The current disk usage of the instance in bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long currentDiskSize;

  /**
   * The database engine type and version, for example MYSQL_5_5 for MySQL 5.5.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String databaseVersion;

  /**
   * Etag for this resource - a version number for the settings object in this resource. This field
   * has no effect when passed as a request parameter. Instead, the contents of this field should be
   * passed in an 'If-Match' http header for use in optimistic locking.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * Name of the database instance. This does not include the project ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String instance;

  /**
   * This is always sql#instance.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The maximum disk size of the instance in bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long maxDiskSize;

  /**
   * The project ID of the project containing the database instance. The Google apps domain is
   * prefixed if applicable. You can find this on the project summary page of the Google APIs
   * Console.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String project;

  /**
   * The geographical region. Can be us-east1 or europe-west1. Defaults to us-east1. The region can
   * not be changed after instance creation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String region;

  /**
   * The user settings.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Settings settings;

  /**
   * The current serving state of the database instance. This can be one of the following. RUNNABLE:
   * The instance is running, or is ready to run when accessed. SUSPENDED: The instance is not
   * available, for example due to problems with billing. PENDING_CREATE: The instance is being
   * created. MAINTENANCE: The instance is down for maintenance. UNKNOWN_STATE: The state of the
   * instance is unknown.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String state;

  /**
   * The current disk usage of the instance in bytes.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCurrentDiskSize() {
    return currentDiskSize;
  }

  /**
   * The current disk usage of the instance in bytes.
   * @param currentDiskSize currentDiskSize or {@code null} for none
   */
  public DatabaseInstance setCurrentDiskSize(java.lang.Long currentDiskSize) {
    this.currentDiskSize = currentDiskSize;
    return this;
  }

  /**
   * The database engine type and version, for example MYSQL_5_5 for MySQL 5.5.
   * @return value or {@code null} for none
   */
  public java.lang.String getDatabaseVersion() {
    return databaseVersion;
  }

  /**
   * The database engine type and version, for example MYSQL_5_5 for MySQL 5.5.
   * @param databaseVersion databaseVersion or {@code null} for none
   */
  public DatabaseInstance setDatabaseVersion(java.lang.String databaseVersion) {
    this.databaseVersion = databaseVersion;
    return this;
  }

  /**
   * Etag for this resource - a version number for the settings object in this resource. This field
   * has no effect when passed as a request parameter. Instead, the contents of this field should be
   * passed in an 'If-Match' http header for use in optimistic locking.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * Etag for this resource - a version number for the settings object in this resource. This field
   * has no effect when passed as a request parameter. Instead, the contents of this field should be
   * passed in an 'If-Match' http header for use in optimistic locking.
   * @param etag etag or {@code null} for none
   */
  public DatabaseInstance setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * Name of the database instance. This does not include the project ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getInstance() {
    return instance;
  }

  /**
   * Name of the database instance. This does not include the project ID.
   * @param instance instance or {@code null} for none
   */
  public DatabaseInstance setInstance(java.lang.String instance) {
    this.instance = instance;
    return this;
  }

  /**
   * This is always sql#instance.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This is always sql#instance.
   * @param kind kind or {@code null} for none
   */
  public DatabaseInstance setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The maximum disk size of the instance in bytes.
   * @return value or {@code null} for none
   */
  public java.lang.Long getMaxDiskSize() {
    return maxDiskSize;
  }

  /**
   * The maximum disk size of the instance in bytes.
   * @param maxDiskSize maxDiskSize or {@code null} for none
   */
  public DatabaseInstance setMaxDiskSize(java.lang.Long maxDiskSize) {
    this.maxDiskSize = maxDiskSize;
    return this;
  }

  /**
   * The project ID of the project containing the database instance. The Google apps domain is
   * prefixed if applicable. You can find this on the project summary page of the Google APIs
   * Console.
   * @return value or {@code null} for none
   */
  public java.lang.String getProject() {
    return project;
  }

  /**
   * The project ID of the project containing the database instance. The Google apps domain is
   * prefixed if applicable. You can find this on the project summary page of the Google APIs
   * Console.
   * @param project project or {@code null} for none
   */
  public DatabaseInstance setProject(java.lang.String project) {
    this.project = project;
    return this;
  }

  /**
   * The geographical region. Can be us-east1 or europe-west1. Defaults to us-east1. The region can
   * not be changed after instance creation.
   * @return value or {@code null} for none
   */
  public java.lang.String getRegion() {
    return region;
  }

  /**
   * The geographical region. Can be us-east1 or europe-west1. Defaults to us-east1. The region can
   * not be changed after instance creation.
   * @param region region or {@code null} for none
   */
  public DatabaseInstance setRegion(java.lang.String region) {
    this.region = region;
    return this;
  }

  /**
   * The user settings.
   * @return value or {@code null} for none
   */
  public Settings getSettings() {
    return settings;
  }

  /**
   * The user settings.
   * @param settings settings or {@code null} for none
   */
  public DatabaseInstance setSettings(Settings settings) {
    this.settings = settings;
    return this;
  }

  /**
   * The current serving state of the database instance. This can be one of the following. RUNNABLE:
   * The instance is running, or is ready to run when accessed. SUSPENDED: The instance is not
   * available, for example due to problems with billing. PENDING_CREATE: The instance is being
   * created. MAINTENANCE: The instance is down for maintenance. UNKNOWN_STATE: The state of the
   * instance is unknown.
   * @return value or {@code null} for none
   */
  public java.lang.String getState() {
    return state;
  }

  /**
   * The current serving state of the database instance. This can be one of the following. RUNNABLE:
   * The instance is running, or is ready to run when accessed. SUSPENDED: The instance is not
   * available, for example due to problems with billing. PENDING_CREATE: The instance is being
   * created. MAINTENANCE: The instance is down for maintenance. UNKNOWN_STATE: The state of the
   * instance is unknown.
   * @param state state or {@code null} for none
   */
  public DatabaseInstance setState(java.lang.String state) {
    this.state = state;
    return this;
  }

  @Override
  public DatabaseInstance set(String fieldName, Object value) {
    return (DatabaseInstance) super.set(fieldName, value);
  }

  @Override
  public DatabaseInstance clone() {
    return (DatabaseInstance) super.clone();
  }

}
