/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-30 at 19:21:28 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.sqladmin.model;

/**
 * Tiers list response.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud SQL Administration API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class TiersListResponse extends com.google.api.client.json.GenericJson {

  /**
   * List of tiers.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Tier> items;

  /**
   * This is always sql#tiersList.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of tiers.
   * @return value or {@code null} for none
   */
  public java.util.List<Tier> getItems() {
    return items;
  }

  /**
   * List of tiers.
   * @param items items or {@code null} for none
   */
  public TiersListResponse setItems(java.util.List<Tier> items) {
    this.items = items;
    return this;
  }

  /**
   * This is always sql#tiersList.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * This is always sql#tiersList.
   * @param kind kind or {@code null} for none
   */
  public TiersListResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public TiersListResponse set(String fieldName, Object value) {
    return (TiersListResponse) super.set(fieldName, value);
  }

  @Override
  public TiersListResponse clone() {
    return (TiersListResponse) super.clone();
  }

}
